#$Header: /usr/cvs/lui/lui/lib/glui.pl,v 1.6 2001/02/28 21:18:01 mchasal Exp $

# Subroutines for individual GLUI panels.
# In order to use these, you need to install the perl-Tk rpm and
# do a "use Tk" in your main program. See the glui script for an 
# example.

#
# open_defserv - Define a server machine panel
#
sub open_defsrv {
	my %ATTRS;
	my %OPTS;
	my $out_p;
	if (! Exists($defsrv_w)) {
		
		# Open a window
		$defsrv_w = $main_w->Toplevel();
		$defsrv_w->title("Define a Server Machine");

		# Define the widgets
		my $ds_name_l=$defsrv_w->Label(-text=>"Name:",-anchor=>"w");
		my $ds_name_ent=$defsrv_w->Entry(-textvariable=>\$ATTRS{'name'});
		$ds_name_l->grid($ds_name_ent,"-",-sticky=>"nsew");

		my $ds_ip_l=$defsrv_w->Label(-text=>"IP Address:",-anchor=>"w");
		my $ds_ip_ent=$defsrv_w->Entry(-textvariable=>\$ATTRS{'ip_address'});
		$ds_ip_l->grid($ds_ip_ent,"-",-sticky=>"nsew");

		my $ds_nm_l=$defsrv_w->Label(-text=>"Netmask:",-anchor=>"w");
		my $ds_nm_ent=$defsrv_w->Entry(-textvariable=>\$ATTRS{'netmask'});
		$ds_nm_l->grid($ds_nm_ent,"-",-sticky=>"nsew");

		my $ds_reboot_l=$defsrv_w->Label(-text=>"Client reboot default:",-anchor=>"w");
		my $ds_reboot_ent=$defsrv_w->Scrolled("Listbox",-scrollbars=>"e",
			-height=>2,-exportselection=>"0");
		$ds_reboot_ent->insert("end","false","true");
		$ds_reboot_ent->selectionSet(0);
		$ds_reboot_l->grid($ds_reboot_ent,"-",-sticky=>"nsew");

		# Make the output pane
		&make_outpane(\$out_p,\$defsrv_w);
		$defsrv_w->gridColumnconfigure(1,-weight=>1);
		$defsrv_w->gridRowconfigure(5,-weight=>1);

		# Make the buttons
		my $fr=$defsrv_w->Frame(-relief=>"groove",-borderwidth=>"2");
		my $ok_b=$fr->Button(-text=>"Apply",
			-command=> sub {
			&cursor(\$defsrv_w,\$out_p,"watch");
			$ATTRS{'type'}="server";
			if (defined $ds_reboot_ent->curselection) {
				$ATTRS{'reboot'}=$ds_reboot_ent->get($ds_reboot_ent->curselection);
			}
			&call_api($out_p,"luiapi::lui_make_machine",\%OPTS,\%ATTRS);
			&cursor(\$defsrv_w,\$out_p,"left_ptr");
			});
		my $clr_b=$fr->Button(-text=>"Clear",
			-command=>sub {
				undef $ATTRS{'name'};
				undef $ATTRS{'ip_address'};
				undef $ATTRS{'netmask'};
				undef $ATTRS{'reboot'};
				$ds_reboot_ent->selectionClear(0,"end");
				$ds_reboot_ent->selectionSet(0);
				$out_p->delete("1.0","end");
				});
		my $can_b=$fr->Button(-text=>"Close",
			-command=> sub {$defsrv_w->withdraw});
		$defsrv_w->bind("<Return>",sub {$ok_b->invoke()});
		$defsrv_w->bind("<Escape>",sub {$can_b->invoke()});
		$fr->grid("-","-",-sticky=>"nsew");
		$ok_b->grid($clr_b,$can_b);
	} else {
		$defsrv_w->deiconify();
		$defsrv_w->raise();
	}
} # open_defsrv	
		
#
# open_defcli - Define a client panel
#
sub open_defcli {
	my %ATTRS;
	my %OPTS;
	my $out_p;
	my $macaddr;
	if (! Exists($defcli_w)) {
		# Open a window
		$defcli_w = $main_w->Toplevel();
		$defcli_w->title("Define a Client Machine");

		# Define the widgets
		my $dc_name_l=$defcli_w->Label(-text=>"Name:",-anchor=>"w");
		my $dc_name_ent=$defcli_w->Entry(-textvariable=>\$ATTRS{'name'});
		$dc_name_l->grid($dc_name_ent,"-",-sticky=>"nsew");

		my $dc_ip_l=$defcli_w->Label(-text=>"IP Address:",-anchor=>"w");
		my $dc_ip_ent=$defcli_w->Entry(-textvariable=>\$ATTRS{'ip_address'});
		$dc_ip_l->grid($dc_ip_ent,"-",-sticky=>"nsew");

		my $dc_nm_l=$defcli_w->Label(-text=>"Netmask:",-anchor=>"w");
		my $dc_nm_ent=$defcli_w->Entry(-textvariable=>\$ATTRS{'netmask'});
		$dc_nm_l->grid($dc_nm_ent,"-",-sticky=>"nsew");

		my $dc_mac_l=$defcli_w->Label(-text=>"MAC Address:",-anchor=>"w");
		my $dc_mac_ent=$defcli_w->Entry(-textvariable=>\$macaddr);
		$dc_mac_l->grid($dc_mac_ent,"-",-sticky=>"nsew");

		my $dc_maci_l=$defcli_w->Label(-text=>"MAC ID:",-anchor=>"w");
		my $dc_maci_ent=$defcli_w->Entry(-textvariable=>\$ATTRS{'mac_id'});
		$dc_maci_l->grid($dc_maci_ent,"-",-sticky=>"nsew");

		my $dc_lhn_l=$defcli_w->Label(-text=>"Long Hostname:",-anchor=>"w");
		my $dc_lhn_ent=$defcli_w->Entry(-textvariable=>\$ATTRS{'lhostname'});
		$dc_lhn_l->grid($dc_lhn_ent,"-",-sticky=>"nsew");

		my $dc_defr_l=$defcli_w->Label(-text=>"Default Route(optional):",-anchor=>"w");
		my $dc_defr_ent=$defcli_w->Entry(-textvariable=>\$ATTRS{'def_route'});
		$dc_defr_l->grid($dc_defr_ent,"-",-sticky=>"nsew");

		my $dc_igw_l=$defcli_w->Label(-text=>"Install Gateway(optional):",-anchor=>"w");
		my $dc_igw_ent=$defcli_w->Entry(-textvariable=>\$ATTRS{'inst_gateway'});
		$dc_igw_l->grid($dc_igw_ent,"-",-sticky=>"nsew");

		my $dc_pbs_l=$defcli_w->Label(-text=>"PBS String(optional):",-anchor=>"w");
		my $dc_pbs_ent=$defcli_w->Entry(-textvariable=>\$ATTRS{'pbs_string'});
		$dc_pbs_l->grid($dc_pbs_ent,"-",-sticky=>"nsew");

		my $dc_grp_l=$defcli_w->Label(-text=>"Machine Groups(optional):",-anchor=>"w");
		my $dc_grp_ent=$defcli_w->Entry(-textvariable=>\$OPTS{'G'});
		$dc_grp_l->grid($dc_grp_ent,"-",-sticky=>"nsew");

		my $dc_reboot_l=$defcli_w->Label(-text=>"Client auto-reboot:",-anchor=>"w");
		my $dc_reboot_ent=$defcli_w->Scrolled("Listbox",-scrollbars=>"e",
			-height=>2,-exportselection=>"0");
		$dc_reboot_ent->insert("end","default","false","true");
		$dc_reboot_ent->selectionSet(0);
		$dc_reboot_l->grid($dc_reboot_ent,"-",-sticky=>"nsew");

		# Make the output pane
		&make_outpane(\$out_p,\$defcli_w);
		$defcli_w->gridColumnconfigure(1,-weight=>1);
		$defcli_w->gridRowconfigure(12,-weight=>1);

		# Make the buttons
		my $fr=$defcli_w->Frame(-relief=>"groove",-borderwidth=>"2");
		my $ok_b=$fr->Button(-text=>"Apply",
			-command=> sub {
			&cursor(\$defcli_w,\$out_p,"watch");
			$ATTRS{'type'}="client";
			$ATTRS{'inst_adptr'}="eth0";
			$ATTRS{'mac_address'}=$macaddr;
			if (defined $dc_reboot_ent->curselection) {
				$ATTRS{'reboot'}=$dc_reboot_ent->get($dc_reboot_ent->curselection);
			}
			&call_api($out_p,"luiapi::lui_make_machine",\%OPTS,\%ATTRS);
			&cursor(\$defcli_w,\$out_p,"left_ptr");
			});
		my $clr_b=$fr->Button(-text=>"Clear",
			-command=>sub {
				undef $ATTRS{'name'};
				undef $ATTRS{'ip_address'};
				undef $ATTRS{'netmask'};
				undef $ATTRS{'mac_address'};
				undef $macaddr;
				undef $ATTRS{'mac_id'};
				undef $ATTRS{'lhostname'};
				undef $ATTRS{'def_route'};
				undef $ATTRS{'inst_gateway'};
				undef $ATTRS{'pbs_string'};
				undef $OPTS{g};
				undef $ATTRS{'reboot'};
				$dc_reboot_ent->selectionClear(0,"end");
				$dc_reboot_ent->selectionSet(0);
				$out_p->delete("1.0","end");
				});
		my $can_b=$fr->Button(-text=>"Close",
			-command=> sub {$defcli_w->withdraw});
		$defcli_w->bind("<Return>",sub {$ok_b->invoke()});
		$defcli_w->bind("<Escape>",sub {$can_b->invoke()});
		$fr->grid("-","-",-sticky=>"nsew");
		$ok_b->grid($clr_b,$can_b);
	} else {
		$defcli_w->deiconify();
		$defcli_w->raise();
	}
} #open_defcli	


#
# open_defclients - Define a set of clients panel
#
sub open_defclients {
	my %OPTS;
	my $out_p;
	if (! Exists($defclients_w)) {
		# Open a window
		$defclients_w = $main_w->Toplevel();
		$defclients_w->title("Define a Set of Client Machines");

		# Define the widgets
		my $dcs_ip_l=$defclients_w->Label(-text=>"Starting IP Address:",-anchor=>"w");
		my $dcs_ip_ent=$defclients_w->Entry(-textvariable=>\$OPTS{'i'});
		$dcs_ip_l->grid($dcs_ip_ent,"-",-sticky=>"nsew");

		my $dcs_nm_l=$defclients_w->Label(-text=>"Netmask:",-anchor=>"w");
		my $dcs_nm_ent=$defclients_w->Entry(-textvariable=>\$OPTS{'m'});
		$dcs_nm_l->grid($dcs_nm_ent,"-",-sticky=>"nsew");

		my $dcs_maci_l=$defclients_w->Label(-text=>"Starting MAC ID(optional):",-anchor=>"w");
		my $dcs_maci_ent=$defclients_w->Entry(-textvariable=>\$OPTS{'I'});
		$dcs_maci_l->grid($dcs_maci_ent,"-",-sticky=>"nsew");

		my $dcs_cnt_l=$defclients_w->Label(-text=>"Number of clients to create(optional):",-anchor=>"w");
		my $dcs_cnt_ent=$defclients_w->Entry(-textvariable=>\$OPTS{'c'});
		$dcs_cnt_l->grid($dcs_cnt_ent,"-",-sticky=>"nsew");

		my $dcs_defr_l=$defclients_w->Label(-text=>"Default Route(optional):",-anchor=>"w");
		my $dcs_defr_ent=$defclients_w->Entry(-textvariable=>\$OPTS{'d'});
		$dcs_defr_l->grid($dcs_defr_ent,"-",-sticky=>"nsew");

		my $dcs_igw_l=$defclients_w->Label(-text=>"Install Gateway(optional):",-anchor=>"w");
		my $dcs_igw_ent=$defclients_w->Entry(-textvariable=>\$OPTS{'g'});
		$dcs_igw_l->grid($dcs_igw_ent,"-",-sticky=>"nsew");

		my $dcs_pbs_l=$defclients_w->Label(-text=>"PBS String(optional):",-anchor=>"w");
		my $dcs_pbs_ent=$defclients_w->Entry(-textvariable=>\$OPTS{'s'});
		$dcs_pbs_l->grid($dcs_pbs_ent,"-",-sticky=>"nsew");

		my $dcs_grp_l=$defclients_w->Label(-text=>"Machine Groups(optional):",-anchor=>"w");
		my $dcs_grp_ent=$defclients_w->Entry(-textvariable=>\$OPTS{'G'});
		$dcs_grp_l->grid($dcs_grp_ent,"-",-sticky=>"nsew");

		my $dcs_reboot_l=$defclients_w->Label(-text=>"Client auto-reboot:",-anchor=>"w");
		my $dcs_reboot_ent=$defclients_w->Scrolled("Listbox",-scrollbars=>"e",
			-height=>2,-exportselection=>"0");
		$dcs_reboot_ent->insert("end","default","false","true");
		$dcs_reboot_ent->selectionSet(0);
		$dcs_reboot_l->grid($dcs_reboot_ent,"-",-sticky=>"nsew");

		# Make the output pane
		&make_outpane(\$out_p,\$defclients_w);
		$defclients_w->gridColumnconfigure(1,-weight=>1);
		$defclients_w->gridRowconfigure(10,-weight=>1);

		# Make the buttons
		my $fr=$defclients_w->Frame(-relief=>"groove",-borderwidth=>"2");
		my $ok_b=$fr->Button(-text=>"Apply",
			-command=> sub {
			if (defined $dcs_reboot_ent->curselection) {
				$OPTS{'r'}=$dcs_reboot_ent->get($dcs_reboot_ent->curselection);
			}
			&cursor(\$defclients_w,\$out_p,"watch");
			&call_api($out_p,"luiapi::lui_make_clients",\%OPTS);
			&cursor(\$defclients_w,\$out_p,"left_ptr");
			});
		my $clr_b=$fr->Button(-text=>"Clear",
			-command=>sub {
				undef $OPTS{'i'};
				undef $OPTS{'I'};
				undef $OPTS{'m'};
				undef $OPTS{'d'};
				undef $OPTS{'g'};
				undef $OPTS{'G'};
				undef $OPTS{'c'};
				undef $OPTS{'s'};
				undef $OPTS{'r'};
				$dcs_reboot_ent->selectionClear(0,"end");
				$dcs_reboot_ent->selectionSet(0);
				$out_p->delete("1.0","end");
				});
		my $can_b=$fr->Button(-text=>"Close",
			-command=> sub {$defclients_w->withdraw});
		$defclients_w->bind("<Return>",sub {$ok_b->invoke()});
		$defclients_w->bind("<Escape>",sub {$can_b->invoke()});
		$fr->grid("-","-",-sticky=>"nsew");
		$ok_b->grid($clr_b,$can_b);
	} else {
		$defclients_w->deiconify();
		$defclients_w->raise();
	}
} #open_defclients

#
# open_defres - Define a resource panel
#
sub open_defres {
	my %ATTRS;
	my %OPTS;
	my $out_p;
	$OPTS{'c'}=1;
	if (! Exists($defres_w)) {
		$defres_w = $main_w->Toplevel();
		$defres_w->title("Define a Resource");

		my $dr_name_l=$defres_w->Label(-text=>"Name:",-anchor=>"w");
		my $dr_name_ent=$defres_w->Entry(-textvariable=>\$ATTRS{'name'});
		$dr_name_l->grid($dr_name_ent,"-",-sticky=>"nsew");

		my $dr_type_l=$defres_w->Label(-text=>"Type:",-anchor=>"w");
		my $dr_type_ent=$defres_w->Scrolled("Listbox",-scrollbars=>"e",
			-height=>3,-exportselection=>"0");
		$dr_type_ent->insert("end","disk","exit","file","kernel","map","ramdisk","rpm","postinstall","source");
		$dr_type_l->grid($dr_type_ent,"-",-sticky=>"nsew");

		my $dr_path_l=$defres_w->Label(-text=>"Full Path Name:",-anchor=>"w");
		my $dr_path_ent=$defres_w->Entry(-textvariable=>\$ATTRS{'source_path_name'});
		$dr_path_l->grid($dr_path_ent,"-",-sticky=>"nsew");

		my $dr_outp_l=$defres_w->Label(-text=>"Output Path Name(optional,source only):",-anchor=>"w");
		my $dr_outp_ent=$defres_w->Entry(-textvariable=>\$ATTRS{'target_location'});
		$dr_outp_l->grid($dr_outp_ent,"-",-sticky=>"nsew");

		my $dr_grp_l=$defres_w->Label(-text=>"Resource Groups(optional):",-anchor=>"w");
		my $dr_grp_ent=$defres_w->Entry(-textvariable=>\$OPTS{'G'});
		$dr_grp_l->grid($dr_grp_ent,"-",-sticky=>"nsew");

		my $dr_ctar_l=$defres_w->Label(-text=>"Create Tar File(file only):",-anchor=>"w");
		my $dr_ctar_ent=$defres_w->Checkbutton(-variable=>\$OPTS{'c'},
			-onvalue=>0, -offvalue=>1);
		$dr_ctar_l->grid($dr_ctar_ent,"-",-sticky=>"nsew");

		# Make the output pane
		&make_outpane(\$out_p,\$defres_w);
		$defres_w->gridColumnconfigure(1,-weight=>1);
		$defres_w->gridRowconfigure(7,-weight=>1);

		# Make the buttons
		my $fr=$defres_w->Frame(-relief=>"groove",-borderwidth=>"2");
		my $ok_b=$fr->Button(-text=>"Apply",
			-command=> sub {
			&cursor(\$defres_w,\$out_p,"watch");
			if (defined $dr_type_ent->curselection) {
				$ATTRS{'type'}=$dr_type_ent->get($dr_type_ent->curselection);
			}
			&call_api($out_p,"luiapi::lui_make_resource",\%OPTS,\%ATTRS);
			&cursor(\$defres_w,\$out_p,"left_ptr");
			});
		my $clr_b=$fr->Button(-text=>"Clear",
			-command=>sub {
				undef $ATTRS{'name'};
				undef $ATTRS{'source_path_name'};
				undef $ATTRS{'target_location'};
				undef $ATTRS{'type'};
				undef $OPTS{G};
				$OPTS{'c'}=1;
				$dr_type_ent->selectionClear("0","end");
				$out_p->delete("1.0","end");
				});
		my $can_b=$fr->Button(-text=>"Close",
			-command=> sub {$defres_w->withdraw});
		$defres_w->bind("<Return>",sub {$ok_b->invoke()});
		$defres_w->bind("<Escape>",sub {$can_b->invoke()});
		$fr->grid("-","-",-sticky=>"nsew");
		$ok_b->grid($clr_b,$can_b);
	} else {
		$defres_w->deiconify();
		$defres_w->raise();
	}
} #open_defres	

#
# open_allres - Allocate resources panel
#
sub open_allres {
	my %ATTRS;
	my %OPTS;
	my $out_p;
	my $name;
	my $mname;
	if (! Exists($alr_w)) {
		$alr_w = $main_w->Toplevel();
		$alr_w->title("Allocate a Resource");

		my $ar_rsrc_l=$alr_w->Label(-text=>"Specify the resources:",
		-relief=>"groove",-borderwidth=>"2");
		$ar_rsrc_l->grid("-","-",-sticky=>"nsew");

		my $ar_name_l=$alr_w->Label(-text=>"Resource Names:",-anchor=>"w");
		my $ar_name_ent=$alr_w->Entry(-textvariable=>\$name);
		$ar_name_l->grid($ar_name_ent,"-",-sticky=>"nsew");

		my $ar_ror_l=$alr_w->Label(-text=>"--OR--");
		$ar_ror_l->grid("-","-",-sticky=>"nsew");

		my $ar_rgrp_l=$alr_w->Label(-text=>"Resource Groups:",-anchor=>"w");
		my $ar_rgrp_ent=$alr_w->Entry(-textvariable=>\$OPTS{'r'});
		$ar_rgrp_l->grid($ar_rgrp_ent,"-",-sticky=>"nsew");

		my $ar_mach_l=$alr_w->Label(-text=>"Specify the machines:",
		-relief=>"groove",-borderwidth=>"2");
		$ar_mach_l->grid("-","-",-sticky=>"nsew");

		my $ar_rnam_l=$alr_w->Label(-text=>"Machine Names:",-anchor=>"w");
		my $ar_rnam_ent=$alr_w->Entry(-textvariable=>\$mname);
		$ar_rnam_l->grid($ar_rnam_ent,"-",-sticky=>"nsew");

		my $ar_mor_l=$alr_w->Label(-text=>"--OR--");
		$ar_mor_l->grid("-","-",-sticky=>"nsew");

		my $ar_mgrp_l=$alr_w->Label(-text=>"Machine Groups:",-anchor=>"w");
		my $ar_mgrp_ent=$alr_w->Entry(-textvariable=>\$OPTS{'g'});
		$ar_mgrp_l->grid($ar_mgrp_ent,"-",-sticky=>"nsew");

		# Make the output pane
		&make_outpane(\$out_p,\$alr_w);
		$alr_w->gridColumnconfigure(1,-weight=>1);
		$alr_w->gridRowconfigure(9,-weight=>1);

		# Make the buttons
		my $fr=$alr_w->Frame(-relief=>"groove",-borderwidth=>"2");
		my $ok_b=$fr->Button(-text=>"Apply",
			-command=> sub {
			&cursor(\$alr_w,\$out_p,"watch");
			$OPTS{'n'}=$name;
			$OPTS{'m'}=$mname;
			&call_api($out_p,"luiapi::lui_allocate_resource",\%OPTS,\%ATTRS);
			&cursor(\$alr_w,\$out_p,"left_ptr");
			});
		my $clr_b=$fr->Button(-text=>"Clear",
			-command=>sub {
				undef $name;
				undef $mname;
				undef $OPTS{'n'};
				undef $OPTS{'m'};
				undef $OPTS{'r'};
				undef $OPTS{'g'};
				$out_p->delete("1.0","end");
				});
		my $can_b=$fr->Button(-text=>"Close",
			-command=> sub {$alr_w->withdraw});
		$alr_w->bind("<Return>",sub {$ok_b->invoke()});
		$alr_w->bind("<Escape>",sub {$can_b->invoke()});
		$fr->grid("-","-",-sticky=>"nsew");
		$ok_b->grid($clr_b,$can_b);
	} else {
		$alr_w->deiconify();
		$alr_w->raise();
	}
} #open_allres	

#
# open_deallres - Deallocate a resouce panel
#
sub open_deallres {
	my %ATTRS;
	my %OPTS;
	my $out_p;
	my $name;
	my $mname;
	if (! Exists($dalr_w)) {
		$dalr_w = $main_w->Toplevel();
		$dalr_w->title("Deallocate a Resource");

		my $dar_rsrc_l=$dalr_w->Label(-text=>"Specify the resources:",
		-relief=>"groove",-borderwidth=>"2");
		$dar_rsrc_l->grid("-","-",-sticky=>"nsew");

		my $dar_name_l=$dalr_w->Label(-text=>"Resource Names:",-anchor=>"w");
		my $dar_name_ent=$dalr_w->Entry(-textvariable=>\$name);
		$dar_name_l->grid($dar_name_ent,"-",-sticky=>"nsew");

		my $dar_ror_l=$dalr_w->Label(-text=>"--OR--");
		$dar_ror_l->grid("-","-",-sticky=>"nsew");

		my $dar_rgrp_l=$dalr_w->Label(-text=>"Resource Groups:",-anchor=>"w");
		my $dar_rgrp_ent=$dalr_w->Entry(-textvariable=>\$OPTS{'r'});
		$dar_rgrp_l->grid($dar_rgrp_ent,"-",-sticky=>"nsew");

		my $dar_aor_l=$dalr_w->Label(-text=>"--OR--");
		$dar_aor_l->grid("-","-",-sticky=>"nsew");

		my $dar_all_l=$dalr_w->Label(-text=>"All resources:",-anchor=>"w");
		my $dar_all_ent=$dalr_w->Checkbutton(-variable=>\$OPTS{'a'},
			-onvalue=>1, -offvalue=>0);
		$dar_all_l->grid($dar_all_ent,"-",-sticky=>"nsew");

		my $dar_mach_l=$dalr_w->Label(-text=>"Specify the machines:",
		-relief=>"groove",-borderwidth=>"2");
		$dar_mach_l->grid("-","-",-sticky=>"nsew");

		my $dar_rnam_l=$dalr_w->Label(-text=>"Machine Names:",-anchor=>"w");
		my $dar_rnam_ent=$dalr_w->Entry(-textvariable=>\$mname);
		$dar_rnam_l->grid($dar_rnam_ent,"-",-sticky=>"nsew");

		my $dar_mor_l=$dalr_w->Label(-text=>"--OR--");
		$dar_mor_l->grid("-","-",-sticky=>"nsew");

		my $dar_mgrp_l=$dalr_w->Label(-text=>"Machine Groups:",-anchor=>"w");
		my $dar_mgrp_ent=$dalr_w->Entry(-textvariable=>\$OPTS{'g'});
		$dar_mgrp_l->grid($dar_mgrp_ent,"-",-sticky=>"nsew");

		# Make the output pane
		&make_outpane(\$out_p,\$dalr_w);
		$dalr_w->gridColumnconfigure(1,-weight=>1);
		$dalr_w->gridRowconfigure(11,-weight=>1);

		# Make the buttons
		my $fr=$dalr_w->Frame(-relief=>"groove",-borderwidth=>"2");
		my $ok_b=$fr->Button(-text=>"Apply",
			-command=> sub {
			&cursor(\$dalr_w,\$out_p,"watch");
			$OPTS{'n'}=$name;
			$OPTS{'m'}=$mname;
			&call_api($out_p,"luiapi::lui_unallocate_resource",\%OPTS,\%ATTRS);
			&cursor(\$dalr_w,\$out_p,"left_ptr");
			});
		my $clr_b=$fr->Button(-text=>"Clear",
			-command=>sub {
				undef $name;
				undef $mname;
				undef $OPTS{'n'};
				undef $OPTS{'m'};
				undef $OPTS{'r'};
				undef $OPTS{'g'};
				$OPTS{'a'}=0;
				$out_p->delete("1.0","end");
				});
		my $can_b=$fr->Button(-text=>"Close",
			-command=> sub {$dalr_w->withdraw});
		$dalr_w->bind("<Return>",sub {$ok_b->invoke()});
		$dalr_w->bind("<Escape>",sub {$can_b->invoke()});
		$fr->grid("-","-",-sticky=>"nsew");
		$ok_b->grid($clr_b,$can_b);
	} else {
		$dalr_w->deiconify();
		$dalr_w->raise();
	}
} #open_deallres	

#
# open_delcli - Delete a client panel
#
sub open_delcli {
	my %ATTRS;
	my %OPTS;
	my $out_p;
	my $name;
	$OPTS{'t'}="client";
	if (! Exists($delm_w)) {
		$delm_w = $main_w->Toplevel();
		$delm_w->title("Delete a Client Machine");

		my $dm_name_l=$delm_w->Label(-text=>"Names:",-anchor=>"w");
		my $dm_name_ent=$delm_w->Entry(-textvariable=>\$name);
		$dm_name_l->grid($dm_name_ent,"-",-sticky=>"nsew");

		my $dm_or_l=$delm_w->Label(-text=>"--OR--");
		$dm_or_l->grid("-","-",-sticky=>"nsew");

		my $dm_grp_l=$delm_w->Label(-text=>"Groups:",-anchor=>"w");
		my $dm_grp_ent=$delm_w->Entry(-textvariable=>\$OPTS{'g'});
		$dm_grp_l->grid($dm_grp_ent,"-",-sticky=>"nsew");

		# Make the output pane
		&make_outpane(\$out_p,\$delm_w);
		$delm_w->gridColumnconfigure(1,-weight=>1);
		$delm_w->gridRowconfigure(4,-weight=>1);

		# Make the buttons
		my $fr=$delm_w->Frame(-relief=>"groove",-borderwidth=>"2");
		my $ok_b=$fr->Button(-text=>"Apply",
			-command=> sub {
			&cursor(\$delm_w,\$out_p,"watch");
			$OPTS{'n'}=$name;
			&call_api($out_p,"luiapi::lui_delete_machine",\%OPTS,\%ATTRS);
			&cursor(\$delm_w,\$out_p,"left_ptr");
			});
		my $clr_b=$fr->Button(-text=>"Clear",
			-command=>sub {
				undef $name;
				undef $OPTS{'n'};
				$out_p->delete("1.0","end");
				});
		my $can_b=$fr->Button(-text=>"Close",
			-command=> sub {$delm_w->withdraw});
		$delm_w->bind("<Return>",sub {$ok_b->invoke()});
		$delm_w->bind("<Escape>",sub {$can_b->invoke()});
		$fr->grid("-","-",-sticky=>"nsew");
		$ok_b->grid($clr_b,$can_b);
	} else {
		$delm_w->deiconify();
		$delm_w->raise();
	}
} #open_delcli	

#
# open_delres - Delete a resource panel
#
sub open_delres {
	my %ATTRS;
	my %OPTS;
	my $out_p;
	my $name;
	$OPTS{'t'}="client";
	if (! Exists($delr_w)) {
		$delr_w = $main_w->Toplevel();
		$delr_w->title("Delete a Resource");

		my $dr_name_l=$delr_w->Label(-text=>"Names:",-anchor=>"w");
		my $dr_name_ent=$delr_w->Entry(-textvariable=>\$name);
		$dr_name_l->grid($dr_name_ent,"-",-sticky=>"nsew");

		my $dr_or_l=$delr_w->Label(-text=>"--OR--");
		$dr_or_l->grid("-","-",-sticky=>"nsew");

		my $dr_grp_l=$delr_w->Label(-text=>"Groups:",-anchor=>"w");
		my $dr_grp_ent=$delr_w->Entry(-textvariable=>\$OPTS{'r'});
		$dr_grp_l->grid($dr_grp_ent,"-",-sticky=>"nsew");

		# Make the output pane
		&make_outpane(\$out_p,\$delr_w);
		$delr_w->gridColumnconfigure(1,-weight=>1);
		$delr_w->gridRowconfigure(4,-weight=>1);

		# Make the buttons
		my $fr=$delr_w->Frame(-relief=>"groove",-borderwidth=>"2");
		my $ok_b=$fr->Button(-text=>"Apply",
			-command=> sub {
			&cursor(\$delr_w,\$out_p,"watch");
			$OPTS{'n'}=$name;
			&call_api($out_p,"luiapi::lui_delete_resource",\%OPTS,\%ATTRS);
			&cursor(\$delr_w,\$out_p,"left_ptr");
			});
		my $clr_b=$fr->Button(-text=>"Clear",
			-command=>sub {
				undef $name;
				undef $OPTS{'n'};
				undef $OPTS{'r'};
				$out_p->delete("1.0","end");
				});
		my $can_b=$fr->Button(-text=>"Close",
			-command=> sub {$delr_w->withdraw});
		$delr_w->bind("<Return>",sub {$ok_b->invoke()});
		$delr_w->bind("<Escape>",sub {$can_b->invoke()});
		$fr->grid("-","-",-sticky=>"nsew");
		$ok_b->grid($clr_b,$can_b);
	} else {
		$delr_w->deiconify();
		$delr_w->raise();
	}
} #open_delres	

#
# open_chmod - Change install mode panel
#
sub open_chmod {
	my %ATTRS;
	my %OPTS;
	my $out_p;
	my $name;

	if (! Exists($chm_w)) {
		$chm_w = $main_w->Toplevel();
		$chm_w->title("Change a Client's Mode");

		my $cm_mach_l=$chm_w->Label(-text=>"Specify the machines:",
		-relief=>"groove",-borderwidth=>"2");
		$cm_mach_l->grid("-","-",-sticky=>"nsew");

		my $cm_name_l=$chm_w->Label(-text=>"Names:",-anchor=>"w");
		my $cm_name_ent=$chm_w->Entry(-textvariable=>\$name);
		$cm_name_l->grid($cm_name_ent,"-",-sticky=>"nsew");

		my $cm_or_l=$chm_w->Label(-text=>"--OR--");
		$cm_or_l->grid("-","-",-sticky=>"nsew");

		my $cm_grp_l=$chm_w->Label(-text=>"Groups:",-anchor=>"w");
		my $cm_grp_ent=$chm_w->Entry(-textvariable=>\$OPTS{'g'});
		$cm_grp_l->grid($cm_grp_ent,"-",-sticky=>"nsew");

		my $cm_mode_l=$chm_w->Label(-text=>"Specify the install mode:",
		-relief=>"groove",-borderwidth=>"2");
		$cm_mode_l->grid("-","-",-sticky=>"nsew");

		my $cm_type_l=$chm_w->Label(-text=>"Mode:",-anchor=>"w");
		my $cm_type_ent=$chm_w->Scrolled("Listbox",-scrollbars=>"e",
			-height=>3,-exportselection=>"0");
		$cm_type_ent->insert("end","disk","install","maint");
		$cm_type_l->grid($cm_type_ent,"-",-sticky=>"nsew");

		# Make the output pane
		&make_outpane(\$out_p,\$chm_w);
		$chm_w->gridColumnconfigure(1,-weight=>1);
		$chm_w->gridRowconfigure(7,-weight=>1);

		# Make the buttons
		my $fr=$chm_w->Frame(-relief=>"groove",-borderwidth=>"2");
		my $ok_b=$fr->Button(-text=>"Apply",
			-command=> sub {
			&cursor(\$chm_w,\$out_p,"watch");
			$OPTS{'n'}=$name;
			if (defined $cm_type_ent->curselection) {
				$OPTS{'m'}=$cm_type_ent->get($cm_type_ent->curselection);
			}
			&call_api($out_p,"luiapi::lui_change_install_mode",\%OPTS,\%ATTRS);
			&cursor(\$chm_w,\$out_p,"left_ptr");
			});
		my $clr_b=$fr->Button(-text=>"Clear",
			-command=>sub {
				undef $name;
				undef $OPTS{'n'};
				undef $OPTS{'m'};
				$cm_type_ent->selectionClear("0","end");
				$out_p->delete("1.0","end");
				});
		my $can_b=$fr->Button(-text=>"Close",
			-command=> sub {$chm_w->withdraw});
		$chm_w->bind("<Return>",sub {$ok_b->invoke()});
		$chm_w->bind("<Escape>",sub {$can_b->invoke()});
		$fr->grid("-","-",-sticky=>"nsew");
		$ok_b->grid($clr_b,$can_b);
	} else {
		$chm_w->deiconify();
		$chm_w->raise();
	}
} #open_chmod	

#
# open_lsmach - List machines panel
#
sub open_lsmach {
	my %ATTRS;
	my %OPTS;
	my $out_p;
	my $name;

	if (! Exists($lsm_w)) {
		$lsm_w = $main_w->Toplevel();
		$lsm_w->title("Display a Machine");

		my $lm_name_l=$lsm_w->Label(-text=>"Names(optional):",-anchor=>"w");
		my $lm_name_ent=$lsm_w->Entry(-textvariable=>\$name);
		$lm_name_l->grid($lm_name_ent,"-",-sticky=>"nsew");
		
		my $lm_or_l=$lsm_w->Label(-text=>"--OR--");
		$lm_or_l->grid("-","-",-sticky=>"nsew");

		my $lm_grp_l=$lsm_w->Label(-text=>"Groups(optional):",-anchor=>"w");
		my $lm_grp_ent=$lsm_w->Entry(-textvariable=>\$OPTS{'g'});
		$lm_grp_l->grid($lm_grp_ent,"-",-sticky=>"nsew");

		# Make the output pane
		&make_outpane(\$out_p,\$lsm_w);
		$lsm_w->gridColumnconfigure(1,-weight=>1);
		$lsm_w->gridRowconfigure(4,-weight=>1);

		# Make the buttons
		my $fr=$lsm_w->Frame(-relief=>"groove",-borderwidth=>"2");
		my $ok_b=$fr->Button(-text=>"Apply",
			-command=> sub {
			&cursor(\$lsm_w,\$out_p,"watch");
			$OPTS{'n'}=$name;
			&call_api($out_p,"luiapi::lui_list_machine",\%OPTS,\%ATTRS);
			&cursor(\$lsm_w,\$out_p,"left_ptr");
			});
		my $clr_b=$fr->Button(-text=>"Clear",
			-command=>sub {
				undef $name;
				undef $OPTS{'n'};
				undef $OPTS{'g'};
				$out_p->delete("1.0","end");
				});
		my $can_b=$fr->Button(-text=>"Close",
			-command=> sub {$lsm_w->withdraw});
		$lsm_w->bind("<Return>",sub {$ok_b->invoke()});
		$lsm_w->bind("<Escape>",sub {$can_b->invoke()});
		$fr->grid("-","-",-sticky=>"nsew");
		$ok_b->grid($clr_b,$can_b);
	} else {
		$lsm_w->deiconify();
		$lsm_w->raise();
	}
} #open_lsmach	

#
# open_lsres - List resources panel
#
sub open_lsres {
	my %ATTRS;
	my %OPTS;
	my $out_p;
	my $name;
	if (! Exists($lsr_w)) {
		$lsr_w = $main_w->Toplevel();
		$lsr_w->title("Display a Resource");

		my $lr_name_l=$lsr_w->Label(-text=>"Names(optional):",-anchor=>"w");
		my $lr_name_ent=$lsr_w->Entry(-textvariable=>\$name);
		$lr_name_l->grid($lr_name_ent,"-",-sticky=>"nsew");

		my $lr_or_l=$lsr_w->Label(-text=>"--OR--");
		$lr_or_l->grid("-","-",-sticky=>"nsew");

		my $lr_grp_l=$lsr_w->Label(-text=>"Groups(optional):",-anchor=>"w");
		my $lr_grp_ent=$lsr_w->Entry(-textvariable=>\$OPTS{'r'});
		$lr_grp_l->grid($lr_grp_ent,"-",-sticky=>"nsew");

		# Make the output pane
		&make_outpane(\$out_p,\$lsr_w);
		$lsr_w->gridColumnconfigure(1,-weight=>1);
		$lsr_w->gridRowconfigure(4,-weight=>1);

		# Make the buttons
		my $fr=$lsr_w->Frame(-relief=>"groove",-borderwidth=>"2");
		my $ok_b=$fr->Button(-text=>"Apply",
			-command=> sub {
			&cursor(\$lsr_w,\$out_p,"watch");
			$OPTS{'n'}=$name;
			&call_api($out_p,"luiapi::lui_list_resource",\%OPTS,\%ATTRS);
			&cursor(\$lsr_w,\$out_p,"left_ptr");
			});
		my $clr_b=$fr->Button(-text=>"Clear",
			-command=>sub {
				undef $name;
				undef $OPTS{'n'};
				undef $OPTS{'r'};
				$out_p->delete("1.0","end");
				});
		my $can_b=$fr->Button(-text=>"Close",
			-command=> sub {$lsr_w->withdraw});
		$lsr_w->bind("<Return>",sub {$ok_b->invoke()});
		$lsr_w->bind("<Escape>",sub {$can_b->invoke()});
		$fr->grid("-","-",-sticky=>"nsew");
		$ok_b->grid($clr_b,$can_b);
	} else {
		$lsr_w->deiconify();
		$lsr_w->raise();
	}
} #open_lsres	

# 
# open_defgrp - Define a group panel
#
sub open_defgrp {
	my %ATTRS;
	my %OPTS;
	my $out_p;
	if (! Exists($defgrp_w)) {
		# Open a window
		$defgrp_w = $main_w->Toplevel();
		$defgrp_w->title("Add Groups or Members");

		my $dg_grp_l=$defgrp_w->Label(-text=>"Group Names:",-anchor=>"w");
		my $dg_grp_ent=$defgrp_w->Entry(-textvariable=>\$OPTS{'g'});
		$dg_grp_l->grid($dg_grp_ent,"-",-sticky=>"nsew");

		my $dg_type_l=$defgrp_w->Label(-text=>"Type:",-anchor=>"w");
		my $dg_type_ent=$defgrp_w->Scrolled("Listbox",-scrollbars=>"e",
			-height=>2,-exportselection=>"0");
		$dg_type_ent->insert("end","machine","resource");
		$dg_type_l->grid($dg_type_ent,"-",-sticky=>"nsew");

		my $dg_mem_l=$defgrp_w->Label(-text=>"Member Names:",-anchor=>"w");
		my $dg_mem_ent=$defgrp_w->Entry(-textvariable=>\$OPTS{'m'});
		$dg_mem_l->grid($dg_mem_ent,"-",-sticky=>"nsew");

		# Make the output pane
		&make_outpane(\$out_p,\$defgrp_w);
		$defgrp_w->gridColumnconfigure(1,-weight=>1);
		$defgrp_w->gridRowconfigure(4,-weight=>1);

		# Make the buttons
		my $fr=$defgrp_w->Frame(-relief=>"groove",-borderwidth=>"2");
		my $ok_b=$fr->Button(-text=>"Apply",
			-command=> sub {
			&cursor(\$defgrp_w,\$out_p,"watch");
			$OPTS{a}=1;
			if (defined $dg_type_ent->curselection) {
				$OPTS{t}=$dg_type_ent->get($dg_type_ent->curselection);
			}
			&call_api($out_p,"luiapi::lui_make_group",\%OPTS);
			&cursor(\$defgrp_w,\$out_p,"left_ptr");
			});
		my $clr_b=$fr->Button(-text=>"Clear",
			-command=>sub {
				undef $OPTS{g};
				undef $OPTS{m};
				$dg_type_ent->selectionClear("0","end");
				$out_p->delete("1.0","end");
				});
		my $can_b=$fr->Button(-text=>"Close",
			-command=> sub {$defgrp_w->withdraw});
		$defgrp_w->bind("<Return>",sub {$ok_b->invoke()});
		$defgrp_w->bind("<Escape>",sub {$can_b->invoke()});
		$fr->grid("-","-",-sticky=>"nsew");
		$ok_b->grid($clr_b,$can_b);
	} else {
		$defgrp_w->deiconify();
		$defgrp_w->raise();
	}
}

#
# open_disgrp - List a group panel
#
sub open_disgrp {
	my %ATTRS;
	my %OPTS;
	my $out_p;
	if (! Exists($disgrp_w)) {
		# Open a window
		$disgrp_w = $main_w->Toplevel();
		$disgrp_w->title("Display Groups or Members");

		my $lg_grp_l=$disgrp_w->Label(-text=>"Group Names(optional):",-anchor=>"w");
		my $lg_grp_ent=$disgrp_w->Entry(-textvariable=>\$OPTS{'g'});
		$lg_grp_l->grid($lg_grp_ent,"-",-sticky=>"nsew");

		# Make the output pane
		&make_outpane(\$out_p,\$disgrp_w);
		$disgrp_w->gridColumnconfigure(1,-weight=>1);
		$disgrp_w->gridRowconfigure(2,-weight=>1);

		# Make the buttons
		my $fr=$disgrp_w->Frame(-relief=>"groove",-borderwidth=>"2");
		my $ok_b=$fr->Button(-text=>"Apply",
			-command=> sub {
			&cursor(\$disgrp_w,\$out_p,"watch");
			&call_api($out_p,"luiapi::lui_list_group",\%OPTS);
			&cursor(\$disgrp_w,\$out_p,"left_ptr");
			});
		my $clr_b=$fr->Button(-text=>"Clear",
			-command=>sub {
				undef $OPTS{g};
				$out_p->delete("1.0","end");
				});
		my $can_b=$fr->Button(-text=>"Close",
			-command=> sub {$disgrp_w->withdraw});
		$disgrp_w->bind("<Return>",sub {$ok_b->invoke()});
		$disgrp_w->bind("<Escape>",sub {$can_b->invoke()});
		$fr->grid("-","-",-sticky=>"nsew");
		$ok_b->grid($clr_b,$can_b);
	} else {
		$disgrp_w->deiconify();
		$disgrp_w->raise();
	}
}

#
# open_delgrp - Delete a group panel
#
sub open_delgrp {
	my %ATTRS;
	my %OPTS;
	my $out_p;
	if (! Exists($delgrp_w)) {
		# Open a window
		$delgrp_w = $main_w->Toplevel();
		$delgrp_w->title("Delete Groups or Members");

		my $rg_grp_l=$delgrp_w->Label(-text=>"Group Names:",-anchor=>"w");
		my $rg_grp_ent=$delgrp_w->Entry(-textvariable=>\$OPTS{'g'});
		$rg_grp_l->grid($rg_grp_ent,"-",-sticky=>"nsew");

		my $rg_mem_l=$delgrp_w->Label(-text=>"Member Names(optional):",-anchor=>"w");
		my $rg_mem_ent=$delgrp_w->Entry(-textvariable=>\$OPTS{'m'});
		$rg_mem_l->grid($rg_mem_ent,"-",-sticky=>"nsew");

		# Make the output pane
		&make_outpane(\$out_p,\$delgrp_w);
		$delgrp_w->gridColumnconfigure(1,-weight=>1);
		$delgrp_w->gridRowconfigure(3,-weight=>1);

		# Make the buttons
		my $fr=$delgrp_w->Frame(-relief=>"groove",-borderwidth=>"2");
		my $ok_b=$fr->Button(-text=>"Apply",
			-command=> sub {
			&cursor(\$delgrp_w,\$out_p,"watch");
			&call_api($out_p,"luiapi::lui_delete_group",\%OPTS);
			&cursor(\$delgrp_w,\$out_p,"left_ptr");
			});
		my $clr_b=$fr->Button(-text=>"Clear",
			-command=>sub {
				undef $OPTS{g};
				undef $OPTS{m};
				$out_p->delete("1.0","end");
				});
		my $can_b=$fr->Button(-text=>"Close",
			-command=> sub {$delgrp_w->withdraw});
		$delgrp_w->bind("<Return>",sub {$ok_b->invoke()});
		$delgrp_w->bind("<Escape>",sub {$can_b->invoke()});
		$fr->grid("-","-",-sticky=>"nsew");
		$ok_b->grid($clr_b,$can_b);
	} else {
		$delgrp_w->deiconify();
		$delgrp_w->raise();
	}
}

#
# call_api - Internally used to call the LUI api
#
sub call_api{
	# Sub to call the LUI API subroutine
	my ($out_p,$api_sub,$OPTS,$ATTRS) = @_;
	$out_p->delete("1.0","end");
	my $line=$out_p->insert("end","Issuing command....\n\n");
	$out_p->update;
	select STDERR;$|=1;
	select STDOUT;$|=1;
	open (STDOUT,">/tmp/glui.out");
	open (STDERR,">/tmp/glui.err");
	&$api_sub(\%$OPTS,\%$ATTRS);
	close (STDOUT);
	close (STDERR);
	open (INFILE,"/tmp/glui.out");
	$out_p->delete("1.0","end");
	$out_p->update;
	while (<INFILE>){
		my $line=$out_p->insert("end",$_);
	}
	open (INFILE,"/tmp/glui.err");
	while (<INFILE>){
		my $line=$out_p->insert("end",$_);
	}
}

#
# make_outpane - Internally used to make the command results pane
#
sub make_outpane {
	my ($out_p,$par_w)=@_;
	# Make the output pane
	my $out_l=$$par_w->Label(-text=>"Command Results:",
		-relief=>"groove",-borderwidth=>"2");
	$out_l->grid("-","-",-sticky=>"nsew");
	$$out_p= $$par_w->Scrolled("ROText",-scrollbars=>"osoe",-takefocus=>"0",
		-wrap=>"none", -height=>"15", -width=>"60", -cursor=>left_ptr);
	$$out_p->grid("-","-",-sticky=>"nsew");
}

#
# cursor - sets the windows cursor to the type given
#
sub cursor {
	my ($topl,$out_p,$type)=@_;
	$$topl->configure(-cursor=>$type);
	$$out_p->configure(-cursor=>$type);
	$$topl->update;
}
1;
