%define name            lui
%define version         1.12.2
%define release         1
%define prefix          /usr/local/%{name}-%{version}

Summary: The Linux Utility for cluster Install.
Name: %name
Version: %version
Release: %release
Copyright: GPL
URL: http://oss.software.ibm.com/lui/
Group: Applications/System
Source: %{name}-%{version}.tar.gz
Requires: perl
Vendor: IBM
Packager: Rich Ferri / Joe Griffin / Michael Chase-Salerno / Sean Dague
Prefix: %prefix
Buildroot: /var/tmp/%{name}-%{version}-root

%description
The Linux Utility for cluster Install (LUI) is an open source utility
for installing Linux workstations remotely, over a network.
What distinguishes LUI is that it is "resource based". LUI provides
tools to manage installation resources on the server, that can be
allocated and applied to installing clients, allowing users to select 
just which resources are right for each client. Examples of resources
supported in LUI are: the linux kernel and associated system map,
the disk partition table, RPMs, user exits, and local and remote (NFS)
file systems.  LUI supports both the BOOTP protocol for diskette based
client installation, as well as true network installation using DHCP 
and PXE.

%prep
%setup -c -n %{name}-%{version}

# No configure, no make, just copy files to the output dir.
%build
cd $RPM_BUILD_DIR/%{name}-%{version}/%{name}-%{version}/
perl Makefile.PL PREFIX=/var/tmp/%{name}-%{version}-root%{prefix}
perl -pi -e 's#(/usr/share/man)#/var/tmp/%{name}-%{version}-root$1#g' Makefile
make
make test
make install
rm -rf /var/tmp/%{name}-%{version}-root%{prefix}/lib/5*
rm -rf /var/tmp/%{name}-%{version}-root%{prefix}/lib/auto*

%clean
rm -fr $RPM_BUILD_DIR/*
rm -rf /var/tmp/%{name}-%{version}-root

%files
%defattr(-,root,root)
%doc %{name}-%{version}/doc/* %{name}-%{version}/C* %{name}-%{version}/R* %{name}-%{version}/M* %{name}-%{version}/W* %{name}-%{version}/I*
%{prefix}/bin
%{prefix}/lib
%{prefix}/templates
%{prefix}/share
%{prefix}/samples
/usr/share/man
%dir %{prefix}

%changelog
* Tue Jul 10 2001 Sean Dague <sldague@us.ibm.com>
- Updates to support LSB locatation of manpages
* Tue Feb 27 2001 Sean Dague <sldague@us.ibm.com>
- Updates for new CPAN build process
* Wed Nov 11 2000 Michael Chase-Salerno <salernom@us.ibm.com>
- Updates for relocatable LUI code.
* Mon Nov 6 2000 Joe Griffin <joe.griffin@mscsoftware.com>
- Initial spec file.
